/*
   This file is part of the Nepomuk KDE project.
   Copyright (C) 2009 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) version 3, or any
   later version accepted by the membership of KDE e.V. (or its
   successor approved by the membership of KDE e.V.), which shall
   act as a proxy defined in Section 6 of version 3 of the license.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _NEPOMUK_QUERY_QUERY_BUILDER_DATA_H_
#define _NEPOMUK_QUERY_QUERY_BUILDER_DATA_H_

#include <QtCore/QString>
#include <QtCore/QLatin1String>

#include "query.h"

namespace Nepomuk {
    namespace Query {
        class QueryBuilderData
        {
        public:
            inline QueryBuilderData( Query::SparqlFlags flags )
                : m_varNameCnt( 0 ),
                  m_flags( flags ) {
            }

            inline Query::SparqlFlags flags() const {
                return m_flags;
            }

            inline QString uniqueVarName() {
                return QLatin1String( "?v" ) + QString::number( ++m_varNameCnt );
            }

        private:
            int m_varNameCnt;
            Query::SparqlFlags m_flags;
        };
    }
}

#endif
